"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getBrowserLanguage = exports.mergeLocales = exports.lowerSnake = void 0;
var shared_1 = require("@designable/shared");
var lowerSnake = function (str) {
    return String(str).replace(/\s+/g, '_').toLocaleLowerCase();
};
exports.lowerSnake = lowerSnake;
var mergeLocales = function (target, source) {
    if (shared_1.isPlainObj(target) && shared_1.isPlainObj(source)) {
        shared_1.each(source, function (value, key) {
            var token = exports.lowerSnake(key);
            var messages = exports.mergeLocales(target[key] || target[token], value);
            target[token] = messages;
        });
        return target;
    }
    else if (shared_1.isPlainObj(source)) {
        var result_1 = Array.isArray(source) ? [] : {};
        shared_1.each(source, function (value, key) {
            var messages = exports.mergeLocales(undefined, value);
            result_1[exports.lowerSnake(key)] = messages;
        });
        return result_1;
    }
    return source;
};
exports.mergeLocales = mergeLocales;
var getBrowserLanguage = function () {
    var _a;
    /* istanbul ignore next */
    if (!window.navigator) {
        return 'en';
    }
    return (window.navigator['browserlanguage'] || ((_a = window.navigator) === null || _a === void 0 ? void 0 : _a.language) || 'en');
};
exports.getBrowserLanguage = getBrowserLanguage;
